/**
 * win32fast/i_monitor.h
 */
#ifndef __WIN32_MONITOR_INCLUDED
#define __WIN32_MONITOR_INCLUDED

#include <windows.h>
#include <await/monitor.h>

namespace await_n {

typedef DWORD threadid_t;

class MonitorImpl: public Monitor {
private:
	LONG m_nLockCount;
	LONG m_nRecursiveCount;
	LONG m_nSleepCount;
	threadid_t m_thrOwner;
	HANDLE m_hEntry;
	HANDLE m_hDelay;
public:
	MonitorImpl();
	virtual ~MonitorImpl();
	virtual void enter();
	virtual void leave();
	virtual bool sleep(AbsoluteMoment);
	virtual void awake();
};

threadid_t getSelfThreadId();

} // namespace await_n

#endif
//=============================================================================
