/**
 * posix/execute.cpp
 */
#include <sys/times.h>
#include <string.h>
#include <thread/thread.h>

namespace thread {

THREAD_API void execute(Runnable *pRunnable, Nanosec &tKernel, Nanosec &tUser) {
	tms before;
	tms after;
	memset(&before, 0, sizeof(before));
	memset(&after, 0, sizeof(after));
	if(pRunnable) {
		times(&before);
		pRunnable->run();
		times(&after);
		pRunnable->decRefCount();
	}
	tKernel = (after.tms_stime - before.tms_stime);
	tKernel *= 1000;
	tUser = (after.tms_utime - before.tms_utime);
	tUser *= 1000;
}

} // namespace thread

//=============================================================================
