/**
 * win32/execute.cpp
 */
#include <windows.h>
#include <thread/thread.h>

namespace thread {

THREAD_API void execute(Runnable *pRunnable, Nanosec &tKernel, Nanosec &tUser) {
	FILETIME unused1, unused2;
	__int64 ftKernelBefore = 0, ftUserBefore = 0;
	__int64 ftKernelAfter = 0, ftUserAfter = 0;
	if(pRunnable) {
		HANDLE hCurrentThread = GetCurrentThread();
		GetThreadTimes(hCurrentThread, &unused1, &unused2, (LPFILETIME) &ftKernelBefore, (LPFILETIME) &ftUserBefore);
		pRunnable->run();
		GetThreadTimes(hCurrentThread, &unused1, &unused2, (LPFILETIME) &ftKernelAfter, (LPFILETIME) &ftUserAfter);
		pRunnable->decRefCount();
	}
	tKernel = (ftKernelAfter - ftKernelBefore)*100;
	tUser = (ftUserAfter - ftUserBefore)*100;
}

} // namespace thread

//=============================================================================
