// speed: main.cpp
#include <stdio.h>
#include <thread/thread.h>
#include <await/await.h>
#include <await/monitor.h>

using namespace thread;
using namespace memory;
using namespace await_n;

enum { ITER_COUNT = 10000000 };
enum { TEST_COUNT = 20 };

struct Test: Runnable {
private:
	Monitor *m_pMonitor;
	int m_nOuterCount;
	int m_nInnerCount;
public:
	Test(int nOuter, int nInner):
		m_pMonitor(getGlobalMonitor()), m_nOuterCount(nOuter), m_nInnerCount(nInner)
	{}
	virtual void run() {
		for(int i=0; i<m_nOuterCount; ++i) {
			for(int j=0; j<m_nInnerCount; ++j)
				m_pMonitor->enter();
			for(int k=0; k<m_nInnerCount; ++k)
				m_pMonitor->leave();
		}
	}
};

int main() {
	Nanosec tKernel, tUser;
	for(int i=0; i<10; ++i) {
		for(int j=0; j<TEST_COUNT; ++j) {
			execute(new Test(ITER_COUNT, i), tKernel, tUser);
#if defined(_MSC_VER)
			printf("%d\t%d\t%I64d\t%I64d\n", ITER_COUNT, i, tKernel, tUser);
#else
			printf("%d\t%d\t%lld\t%lld\n", ITER_COUNT, i, tKernel, tUser);
#endif
		}
	}
	return 0;
}

//============================================================================
